#!/usr/local/bin/python3

import sys
import os

def main(workpath):
    if not os.path.exists(workpath):
        print("***ERROR(py_generate_textreport.py): Not find %s" %(workpath))
        return
    else:
        if not (os.path.exists(workpath+"/bbovrs") and os.path.exists(workpath+"/tmp") and os.path.exists(workpath+"/rtk_smooth")):
            print("***ERROR(py_generate_textreport.py): the workspace is incomplete: %s" %(workpath))
            return
    pass

    fid_w = open("Report_DataProcess","w",encoding = 'utf-8')
    # RTK
    fid_w.write("+PART 1 PROJECT INFORMATION: RTK\n")
    ## basic information
    fid_w.write(" +SECT 1 BASIC INFORMATION\n")
    baseline = []
    nbaseline = 0
    if os.path.exists(workpath+"/rtk_smooth/bs.config"):
        fid_o = open(workpath+"/rtk_smooth/bs.config")
        for line in fid_o:
            if len(line.strip()) <= 0:
                continue
            if "TIME" in line:
                fid_w.write(" "+line.strip()+"\n")
            if "RECORD" in line:
                value = line.split()
                baseline.append([value[1],value[2]])
        nbaseline = len(baseline)
        fid_w.write(" Number of BASELINE: %d\n" % (nbaseline))
        if nbaseline > 0:
            fid_w.write(" List of BASELINE:\n")
            for i in range(nbaseline):
                fid_w.write("   LINE%3d: %s(r) %s(b)\n" % (i+1,baseline[i][0].upper(),baseline[i][1].upper()))
        fid_o.close()
    fid_w.write(" -SECT 1 BASIC INFORMATION\n")
    ## ambfix information
    fid_w.write(" +SECT 2 AMBFIX INFORMATION\n")
    if nbaseline > 0:
        for i in range(nbaseline):
            N1_path = workpath+"/rtk_smooth/"+baseline[i][0].lower()+"_"+baseline[i][1].lower()+"/N1.con"
            if not os.path.exists(N1_path):
                continue
            fid_w.write("   LINE%3d AMBFIX RATE:\n" % (i+1))
            fid_o = open(N1_path)
            for line in fid_o:
                if len(line.strip()) <= 0:
                    continue
                if "SYS / FIX RATE" in line:
                    value = line.split()
                    fid_w.write("   %12s%12s\n" % (value[0],value[1]))
            fid_o.close()

    fid_w.write(" -SECT 2 AMBFIX INFORMATION\n")

    fid_w.write("-PART 1 PROJECT INFORMATION: RTK\n")
    fid_w.write("\n")
    # VRS
    fid_w.write("+PART 2 PROJECT INFORMATION: VRS\n")
    ## basic information
    fid_w.write(" +SECT 1 BASIC INFORMATION\n")
    baseline_vrs = []
    nbaseline_vrs = 0
    if os.path.exists(workpath+"/bbovrs/line_ite"):
        fid_o = open(workpath+"/bbovrs/line_ite")
        for line in fid_o:
            if len(line.strip()) <= 0:
                continue
            value = line.split()
            baseline_vrs.append([value[0],value[1]])
        nbaseline_vrs = len(baseline_vrs)
        fid_w.write(" Number of BASELINE: %d\n" % (nbaseline_vrs))
        if nbaseline_vrs > 0:
            fid_w.write(" List of BASELINE:\n")
            for i in range(nbaseline_vrs):
                fid_w.write("   LINE%3d: %s(r) %s(b)\n" % (i+1,baseline_vrs[i][0].upper(),baseline_vrs[i][1].upper()))
        fid_o.close()
    fid_w.write(" -SECT 1 BASIC INFORMATION\n")
    ## atomsphere
    fid_w.write(" +SECT 2 ATOMSPHERE INFORMATION\n")
    fid_w.write(" -SECT 2 ATOMSPHERE INFORMATION\n")

    fid_w.write("-PART 2 PROJECT INFORMATION: VRS\n")
    fid_w.close()

if __name__  == '__main__':   
    message='命令错误'
    if not len(sys.argv)==2:
        print(message)
        sys.exit()
    main(sys.argv[1])