#!/usr/local/bin/python3
import sys
import os

def readstationXYZ(filepath):
    stationlist=[]
    with open(filepath,'r',encoding='utf-8') as readfile:
        for line in readfile:
            if len(line.strip('\n')) <= 0:
                continue
            station=[]
            data_line=line.strip('\n').split()
            station.append(data_line[0])#name
            station.append(float(data_line[1]))#X
            station.append(float(data_line[2]))#Y
            station.append(float(data_line[3]))#Z
            stationlist.append(station)
    return stationlist

if __name__ == "__main__":
    message='命令错误'
    if len(sys.argv)<=1 :
        print(message)
        sys.exit()

    inputfile = sys.argv[1]
    outputfile = sys.argv[2]
    if not os.path.exists(inputfile):
        print(message)
        sys.exit()

    Station_XYZ = readstationXYZ(inputfile)

    site_num = len(Station_XYZ)
    if site_num <= 1:
        print(message)
        sys.exit()
    
    # we choose the 1st site to the base station
    baseline_num = site_num - 1
    with open(outputfile,'w',encoding='utf-8') as writefile:
        t_str = "nbaseline " + str(int(baseline_num)) + "\n"
        writefile.write(t_str)
        for i in range(baseline_num):
            t_str = "RECORD" + str(int(i + 1)) + ": " + Station_XYZ[i + 1][0] + " " + Station_XYZ[0][0] + "\n"
            writefile.write(t_str)
