#!/usr/local/bin/python3
import sys
import math as mt

a = 6378137.0  
b = 6356752.31414 
a = 6378137.0 
f = 1 / 298.257223563 
b = 6356752.31414  
sqrt = mt.sqrt
sin = mt.sin
cos = mt.cos
atan = mt.atan
atan2 = mt.atan2
fabs = mt.fabs

def rad2angle(r):
    a = r * 180.0 / mt.pi
    return a

def angle2rad(a):
    r = a * mt.pi / 180.0
    return r

def XYZ2BLH(X, Y, Z):
    R = sqrt(X * X + Y * Y)
    B0 = atan2(Z, R)
    while 1:
        N = a / sqrt(1.0 - f * (2 - f) * sin(B0) * sin(B0))
        B_ = atan2(Z + N * f * (2 - f) * sin(B0), R)
        if (fabs(B_ - B0) < 1.0e-7):
            break
        B0 = B_
    L_ = atan2(Y, X)
    H = R / cos(B_) - N
    B = rad2angle(B_)
    L = rad2angle(L_)
    return B, L, H


def calculate_sec(starttime,endtime):
    data_stime=starttime.strip('\n').split()
    data_etime=endtime.strip('\n').split()  #转换为列表
    sday=int(data_stime[2])
    shour=int(data_stime[3])
    sminute=int(data_stime[4])
    ssec=int(data_stime[5])
    eday=int(data_etime[2])
    ehour=int(data_etime[3])
    eminute=int(data_etime[4])
    esec=int(data_etime[5])
    all_sec=(eday*86400+ehour*3600+eminute*60+esec)-(sday*86400+shour*3600+sminute*60+ssec)
    return all_sec
pass

def readdownstainform(filepath):
    with open(filepath,'r',encoding='utf-8') as readfile:
        num=0
        starttime=''
        endtime=''
        stationname=[]
        for line in readfile:
            data_line=line.strip('\n').split()
            if num==0:starttime=data_line[0]+' '+data_line[1]+' '+data_line[2]+' '+data_line[3]+' '+data_line[4]+' '+data_line[5];\
                endtime=data_line[6]+' '+data_line[7]+' '+data_line[8]+' '+data_line[9]+' '+data_line[10]+' '+data_line[11]
            stationname.append(data_line[12])
            num=num+1
        allinformation=[]
        allinformation.append(num)
        time=calculate_sec(starttime,endtime)
        starttime=starttime+' '+str(time)
        allinformation.append(starttime)
        allinformation.append(stationname)
    return allinformation
            
def readoutstation(filepath,stationname):
    stationXYZ=[]
    for i in range(len(stationname)):
        with open(filepath,'r',encoding='utf-8') as readfile:
            for line in readfile:
                XYZ=[]
                data_line=line.strip('\n').split()
                if data_line[0]==stationname[i]:
                    XYZ.append(stationname[i])
                    XYZ.append(data_line[1]);XYZ.append(data_line[2]);\
                    XYZ.append(data_line[3]);stationXYZ.append(XYZ);break
    return stationXYZ
    # with open(filepath,'r',encoding='utf-8') as readfile:
    #     stationXYZ=[]
    #     num=0
    #     for line in readfile:
    #         XYZ=[]
    #         data_line=line.strip('\n').split()
    #         for i in range(len(stationname)):
    #             if data_line[0]==stationname[i]:
    #                 XYZ.append(stationname[i])
    #                 XYZ.append(data_line[1]);XYZ.append(data_line[2]);\
    #                 XYZ.append(data_line[3]);stationXYZ.append(XYZ);num=num+1;break
    #         if num==int(len(stationname)) :break
    # return stationXYZ
            

if __name__  == '__main__':  
    message='命令错误'
    if len(sys.argv)<=1 :
        print(message)
        sys.exit()
    #time  station_id  station_num
    downinform=readdownstainform(sys.argv[1])
    #print(downinform)
    #station_XYZ
    stationXYZ=readoutstation(sys.argv[2],downinform[2])  #存在重复测站问题(改为先找到就用)
    #print(stationXYZ)
    
    #obsdir   brdmdir
    obsdir=sys.argv[3]
    brdmdir=sys.argv[4]
    
    
    #开始写文件
    with open(sys.argv[5],'w',encoding='utf-8') as writefile:
        str1='TIME '+downinform[1]+'\n'
        writefile.write(str1)
        str2='obsdir '+obsdir+'\n'
        writefile.write(str2)
        str3='brdmdir '+brdmdir+'\n'
        writefile.write(str3)
        # str4='nbaseline '+str(downinform[0])+'\n'
        # writefile.write(str4)
        
    with open(sys.argv[6],'w',encoding='utf-8') as writefile:
        for i in range(len(downinform[2])):
            strstation=''
            strstation=str(stationXYZ[i][0])+' '+str(stationXYZ[i][1])+' '+str(stationXYZ[i][2])+' '+str(stationXYZ[i][3])+'\n'
            writefile.write(strstation)
    
    #生成基线需要经纬度，转换为高斯坐标系      
    with open(sys.argv[7],'w',encoding='utf-8') as writefile:
        for i in range(len(downinform[2])):
            BLH=XYZ2BLH(float(stationXYZ[i][1]),float(stationXYZ[i][2]),float(stationXYZ[i][3]))
            strstation=''
            strstation=stationXYZ[i][0]+' '+str('{:.4f}'.format(BLH[0]))+' '+str('{:.4f}'.format(BLH[1]))+' '+str('{:.4f}'.format(BLH[2]))+' '+str(stationXYZ[i][1])+' '+str(stationXYZ[i][2])+' '+str(stationXYZ[i][3])+'\n'
            writefile.write(strstation)
    

    





